"""Assorted useful combinatorics.
"""

from __future__ import generators


def xunique_combinations(items, n):
    """Iterate through unordered, length `n` subsets of `items`.

    >>> for c in xunique_combinations([1, 2, 3], 2):
    ...     print c
    [1, 2]
    [1, 3]
    [2, 3]
    """
    if n==0: yield []
    else:
        for i in xrange(len(items)):
            for cc in xunique_combinations(items[i+1:],n-1):
                yield [items[i]]+cc
